#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivitySailingaShopCFG.h"
std::auto_ptr<M_ActivitySailingaShopCFG> M_ActivitySailingaShopCFG::msSingleton(nullptr);

int M_ActivitySailingaShopCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivitySailingaShopCFGData* M_ActivitySailingaShopCFG::GetData(int Id)
{
	auto it = mMapData.find(Id);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivitySailingaShopCFGData>& M_ActivitySailingaShopCFG::GetMapData()
{
	return mMapData;
}

void M_ActivitySailingaShopCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivitySailingaShopCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivitySailingaShopCFGData data;
		data.mId = element->IntAttribute("Id");
		data.mItemName = element->Attribute("ItemName");
		data.mItemId = element->IntAttribute("ItemId");
		data.mItemCount = element->IntAttribute("ItemCount");
		data.mVipLevel = element->IntAttribute("VipLevel");
		data.mWeight = element->IntAttribute("Weight");
		if (mMapData.find(data.mId) != mMapData.end())std::cout <<"data refind:" << data.mId << std::endl;
		CCASSERT(mMapData.find(data.mId) == mMapData.end(), "data.mId is exists");
		mMapData.insert(std::make_pair(data.mId, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivitySailingaShopCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivitySailingaShopCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivitySailingaShopCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivitySailingaShopCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivitySailingaShopCFGData data;
		LuaCfgHelper::readInt(L, "Id", data.mId);
		LuaCfgHelper::readString(L, "ItemName", data.mItemName);
		LuaCfgHelper::readInt(L, "ItemId", data.mItemId);
		LuaCfgHelper::readInt(L, "ItemCount", data.mItemCount);
		LuaCfgHelper::readInt(L, "VipLevel", data.mVipLevel);
		LuaCfgHelper::readInt(L, "Weight", data.mWeight);
		if (mMapData.find(data.mId) != mMapData.end())std::cout <<"data refind:" << data.mId << std::endl;
		CCASSERT(mMapData.find(data.mId) == mMapData.end(), "data.mId is exists");
		mMapData.insert(std::make_pair(data.mId, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivitySailingaShopCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivitySailingaShopCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivitySailingaShopCFG* M_ActivitySailingaShopCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivitySailingaShopCFG());
	}
	return msSingleton.get();
}

void M_ActivitySailingaShopCFG::Release()
{
	msSingleton.reset(nullptr);
}
